﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Controls.Theming;

namespace ThemingDemo
{
	public class ChangeThemeCommand : ICommand
	{
		#region ICommand Members

		public bool CanExecute(object parameter)
		{
			return true;
		}

		public event EventHandler CanExecuteChanged;

		public void Execute(object parameter)
		{
			if (Application.Current.RootVisual == null)
			{
				return;
			}

			Theme themeContainer = (Theme)((FrameworkElement)Application.Current.RootVisual).FindName("ThemeContainer");

			if (themeContainer == null)
			{
				return;
			}

			ThemeData data = parameter as ThemeData;

			if (data == null || string.IsNullOrEmpty(data.Path))
			{
				themeContainer.ThemeUri = null;
			}
			else
			{
				themeContainer.ThemeUri = new Uri(data.Path, UriKind.RelativeOrAbsolute);
			}

			if (CanExecuteChanged != null)
			{
				CanExecuteChanged(this, new EventArgs());
			}
		}

		#endregion
	}
}
